import React, {Component} from 'react';
import { View } from 'react-native';
import { connect } from 'react-redux';
import {RTCView} from 'react-native-webrtc';

class MainVideo extends Component{
    
    constructor(props){
        super(props);
    }

    componentDidMount(){
        this.updateDominantVideoId();
    }

    componentDidUpdate(){
        this.updateDominantVideoId();
    }

    updateDominantVideoId(){
        // if(this.props.dominantVideoId == null && this.props.users.length != 0){
        //     if(this.props.users[0].videoTrack != null){
        //         this.props.updateDominantVideoId(this.props.users[0].id);
        //     }
        // }

        if(this.props.dominantVideoId == null){
           
            this.props.updateDominantVideoId('localVideo');
        }

    }

    render(){
        return(
            <View id="rt_container" style={this.style.rt_container}>
                {
                    this.props.users.map((user,index) => {
                        if(user.id == this.props.dominantVideoId && user.videoTrack != null){
                            return(
                                <RTCView
                                    key={index}
                                    objectFit = "cover"
                                    streamURL = { user.videoTrack.getOriginalStream().toURL() }
                                    style={{ flex: 1 , height: '100%', width: '100%' }}
                                    zOrder={0}
                                />
                            )    
                        }
                    })
                }
                {
                    this.props.users.length == 0 ? 
                    <RTCView objectFit = "cover" streamURL = { this.props.localUrl } style={{ flex: 1 , height: '100%', width: '100%' }} zOrder={0} /> 
                    : 
                    this.props.dominantVideoId == 'localVideo' ? 
                        <RTCView objectFit = "cover" streamURL = { this.props.localUrl } style={{ flex: 1 , height: '100%', width: '100%' }} zOrder={0} /> : null
                }
            </View>
        )
    }

    style = {
        rt_container: { height: '100%', width: '100%', position: 'absolute', left: 0, top: 0, zIndex: 1 }
    };
}

function mapStateToProps (state) {
    return {
        localUrl: state.url.localUrl,
        localTrackId: state.url.localTrackId,
        localTracks: state.tracks.localTracks,
        remoteTracks: state.tracks.remoteTracks,
        users : state.tracks.users,
        dominantVideoId: state.tracks.dominantVideoId
    }
}

function mapDispatchToProps(dispatch){
    return{
        updateDominantVideoId: (id) => dispatch(data.updateDominantVideoId(id))
    }
}


export default connect(mapStateToProps, mapDispatchToProps)(MainVideo)